<?php
/*
= LuxCal information text editor page =

This file is part of the LuxCal Web Calendar.
Copyright 2009-2023 LuxSoft - www.LuxSoft.eu
License https://www.gnu.org/licenses/gpl.html GPL version 3

The LuxCal Web Calendar is distributed WITHOUT ANY WARRANTY.
*/

//sanity check
if (empty($lcV)) { exit('not permitted ('.substr(basename(__FILE__),0,-4).')'); } //launch via script only

//initialize
$adminLang = (file_exists("./lang/ai-{$opt['cL']}.php")) ? $opt['cL'] : "english";
require "./lang/ai-{$adminLang}.php";

function editForm() {
	global $formCal, $ax, $infoText;
	
	echo "<form action='index.php' method='post'>
{$formCal}
<fieldset>\n
<legend>{$ax['edi_edit_text']}</legend>\n
<br><textarea name='infoText' rows='30' cols='1' style='width:40vw'>{$infoText}</textarea><br>
</fieldset>\n
<button type='submit' name='action' value='save'>{$ax['edi_save']}</button>&ensp;\n
<button type='submit' name='action' value='backup'>{$ax['edi_backup']}</button>\n
</form>\n";
}

function submit($action) {
	global $ax, $infoText, $fName;
	
	if ($action == 'save') {
		file_put_contents($fName,$infoText);
		$msg = str_replace('$1',$fName,$ax['edi_text_saved']);
	} elseif ($action == 'backup') {
		if (!$infoText) {
			$msg = $ax['edi_no_text'];
		} else {
			$fNameBu = str_replace(".txt",'-'.date('Ymd-His').'.txt',$fName);
			file_put_contents($fNameBu,$infoText);
			$msg = str_replace('$1',$fNameBu,$ax['edi_text_saved']);
		}
	}
	return $msg;
}


//init
$msg = '';
$fName = "./sidepanel/info.txt";
$action = $_POST["action"] ?? 'edit'; //save, backup or edit
$infoText = $_POST["infoText"] ?? '';
if (!$infoText and file_exists($fName)) {
	$infoText = htmlentities(file_get_contents($fName));
}

//control logic
if ($usr['privs'] >= 4) {
	if ($action != 'edit') { //submit
		$msg = submit($action);
	}
	echo $msg ? "<p class='error'>{$msg}</p>\n" : "<p>&nbsp;</p>\n";
	echo "<aside class='aside sBoxAd'>{$ax['xpl_edit_info']}</aside>\n";
	echo "<div class='centerBox sBoxAd'>\n";
	editForm(); //edit info form
	echo "</div>\n";
} else {
	echo "<p class='error'>{$ax['no_way']}</p>\n";
}
?>